package yrpg.bamp.base.plugin.operate;

import kd.bos.dataentity.OperateOption;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.operate.result.OperationResult;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.PreparePropertysEventArgs;
import kd.bos.entity.plugin.args.AfterOperationArgs;
import kd.bos.entity.plugin.args.BeginOperationTransactionArgs;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.coderule.CodeRuleServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import kd.sdk.plugin.Plugin;

import java.time.LocalDate;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 单据操作插件 人员同步至人员级别
 */
public class PersonSaveToLimitOpPlugin extends AbstractOperationServicePlugIn implements Plugin {
    public void onPreparePropertys(PreparePropertysEventArgs e){

        e.getFieldKeys().add("name");
        e.getFieldKeys().add("number");
        e.getFieldKeys().add("yrpg_rank");
    }


    @Override
    public void afterExecuteOperationTransaction(AfterOperationArgs e) {
        super.afterExecuteOperationTransaction(e);
        DynamicObject[] dataEntities = e.getDataEntities();
        List<DynamicObject> successObjs = new ArrayList<>();
        //获取当前年份
        LocalDate currentDate = LocalDate.now();
        int currentYear = currentDate.getYear();
        List<DynamicObject> infos = new ArrayList<DynamicObject>();
        List<DynamicObject> infos1 = new ArrayList<DynamicObject>();
        for (DynamicObject dataEntity : dataEntities) {
            //获取是否有当前年度人员级别
            QFilter qFilter = new QFilter("yrpg_person.id", QCP.equals,dataEntity.getPkValue());
            QFilter yearqFilter = new QFilter("yrpg_year", QCP.equals,currentYear);
            DynamicObject yrpgPersonlevel = BusinessDataServiceHelper.loadSingle("yrpg_personlevel", "number,name,creator,yrpg_person,yrpg_year,yrpg_type,yrpg_level,status,yrpg_issync,modifytime", new QFilter[]{qFilter, yearqFilter});
            //没有新增，有则修改
            if(yrpgPersonlevel==null){
                yrpgPersonlevel = BusinessDataServiceHelper.newDynamicObject("yrpg_personlevel");
                yrpgPersonlevel.set("creator",dataEntity);
                yrpgPersonlevel.set("status","C");
                yrpgPersonlevel.set("yrpg_type","1");
                yrpgPersonlevel.set("yrpg_issync",true);
                yrpgPersonlevel.set("enable","1");
                yrpgPersonlevel.set("createtime",new Date());
                yrpgPersonlevel.set("yrpg_year",currentYear);
                //通过编码规则获取编码
                String number = CodeRuleServiceHelper.getNumber("yrpg_personlevel", yrpgPersonlevel, null);
                yrpgPersonlevel.set("number",number);

                yrpgPersonlevel.set("yrpg_person",dataEntity);
                yrpgPersonlevel.set("yrpg_level",dataEntity.getString("yrpg_rank"));
                infos1.add(yrpgPersonlevel);


            }else{
//                if("2".equals(yrpgPersonlevel.getString("yrpg_type"))){
//                   continue;
//               }
                //当历史数据不是同步数据时不处理-研发或其他手工修改数据不覆盖
                if(!yrpgPersonlevel.getBoolean("yrpg_issync")){
                    continue;
                }
                yrpgPersonlevel.set("yrpg_person",dataEntity);
                yrpgPersonlevel.set("yrpg_level",dataEntity.getString("yrpg_rank"));
                infos.add(yrpgPersonlevel);
            }
        }
        //保存数据
        if(infos.size()>0){
            OperationResult result = SaveServiceHelper.saveOperate("yrpg_personlevel", infos.toArray(new DynamicObject[0]), OperateOption.create());
        }
        if(infos1.size()>0){
            OperationResult result = SaveServiceHelper.saveOperate("yrpg_personlevel", infos1.toArray(new DynamicObject[0]), OperateOption.create());
        }
    }
}